// Libraries
#include "ESP8266WiFi.h"
#include "Adafruit_MQTT.h"
#include "Adafruit_MQTT_Client.h"

// DHT 22 sensor // 
#define potentiometer A0
int lockState = 8;



#define WLAN_SSID       "OREN6"
#define WLAN_PASS       "035355737"

// Adafruit IO
#define AIO_SERVER      "io.adafruit.com"
#define AIO_SERVERPORT  1883
#define AIO_USERNAME    "May811"
#define AIO_KEY         "aio_ewYM31QVdRnvvOlhIjqvLLcEXSlm"


// Functions
void connect();

// Create an ESP8266 WiFiClient class to connect to the MQTT server.
WiFiClient client;

// Store the MQTT server, client ID, username, and password in flash memory.
const char MQTT_SERVER[] = AIO_SERVER;

// Set a unique MQTT client ID using the AIO key + the date and time the sketch
// was compiled (so this should be unique across multiple devices for a user,
// alternatively you can manually set this to a GUID or other random value).
const char MQTT_CLIENTID[] = AIO_KEY __DATE__ __TIME__;
const char MQTT_USERNAME[] = AIO_USERNAME;
const char MQTT_PASSWORD[] = AIO_KEY;

// Setup the MQTT client class by passing in the WiFi client and MQTT server and login details.
Adafruit_MQTT_Client mqtt(&client, MQTT_SERVER, AIO_SERVERPORT, MQTT_CLIENTID, MQTT_USERNAME, MQTT_PASSWORD);/****************************** Feeds ***************************************/

// Setup feeds for temperature & humidity
const char KEY_FEED[] = AIO_USERNAME "/feeds/Led";
Adafruit_MQTT_Publish  key = Adafruit_MQTT_Publish(&mqtt, KEY_FEED);


const char isAsleep_FEED[] = AIO_USERNAME "/feeds/thermin"
Adafruit_MQTT_Publish  isAsleep = Adafruit_MQTT_Publish(&mqtt, KEY_FEED);
/*************************** Sketch Code ************************************/

void setup() {

  // Init sensor
    lockState = analogRead(potentiometer);
    lockState = map(lockState, 0, 1023, 0, 9);
    lockState = constrain(lockState, 0, 9);

  Serial.begin(115200);
  delay(10);
  Serial.println("Adafruit IO Example");
  Serial.println();
  Serial.println();
  Serial.print("Connecting to ");
  Serial.println(WLAN_SSID);

  WiFi.begin(WLAN_SSID, WLAN_PASS);
  // wait for WiFi connection
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
    delay(5);
  }

  Serial.println("");
  Serial.println("WiFi connected");
  Serial.println("IP address: ");
  Serial.println(WiFi.localIP());
  Serial.println();
  // connect to adafruit io
  connect();
}

void loop() {

   lockState = analogRead(potentiometer);
   
  // ping adafruit io a few times to make sure we remain connected
  if (! mqtt.ping(3)) {
    // reconnect to adafruit io
    if (! mqtt.connected())
      connect();
  }

  // Grab the current state of the sensor
  Serial.println(lockState);
  boolean isLock = (lockState == 1024);
  

  // Publish data
    
   Serial.println(isLock);
  if (! key.publish(isLock))
    Serial.println("Failed to publish Lock status");
  else
    Serial.println("Lock status published!");

  delay(10000);

}

// connect to adafruit io via MQTT
void connect() {
  Serial.print("Connecting to Adafruit IO... ");
  int8_t ret;
  while ((ret = mqtt.connect()) != 0) {
    switch (ret) {
      case 1: Serial.println("Wrong protocol"); break;
      case 2: Serial.println("ID rejected"); break;
      case 3: Serial.println("Server unavail"); break;
      case 4: Serial.println("Bad user/pass"); break;
      case 5: Serial.println("Not authed"); break;
      case 6: Serial.println("Failed to subscribe"); break;
      default: Serial.println("Connection failed"); break;
    }
    if (ret >= 0) {
      mqtt.disconnect();
    }
    Serial.println("Retrying connection...");
    delay(5000);
  }
  Serial.println("Adafruit IO Connected!");
}


//#define AIO_USERNAME    "zvikapika"
//#define AIO_KEY         "ec187b5663ef40cf40eb23a465acf72903278341"
